package workshop;

import workshop.core.*;
import workshop.utils.*;

public class Workshop
{
   public static void main(String[] args)
   {
      int laborer = 0;
      char charInput;
      
      //Parsing dei dati in ingresso
      CommandLineParser CLP =new  CommandLineParser(args);
      ConfRegister.setConfigurationFilePath(CLP.getInputFilePath());
      ConfRegister.setJobRequested(CLP.getJobNumber());
      ConfRegister.setLaborerRequested(CLP.getLaborerNumber());
      
      
      //Creazione dei thread
      Laborer[] laborersArray = new Laborer[ConfRegister.getLaborerRequested()];
      JobsGenerator.self();
      JobsSupervisor.self();
      
      for (; laborer < ConfRegister.getLaborerRequested(); laborer++)
      {
         laborersArray[laborer] = new Laborer("Laborer" + String.valueOf(laborer));
         JobsSupervisor.self().addLaborer(laborersArray[laborer]);
      }
      
      Statistics stat = new Statistics();
      
      // Ciclo per interrompere il programma e/o metterlo in pausa 
      while (true)
      {
         try
         {
            charInput = (char) System.in.read();

            
            //Caso in l'utente voglia chiudere l'applicazuone
            if (charInput == ConfRegister.QUIT_CHAR)
            {
               System.exit(0);
            }
            
            //Caso in cui l'utente voglia fermare l'applicazione
            if (charInput == ConfRegister.PAUSE_CHAR)
            {
               JobsGenerator.self().pause();
               JobsSupervisor.self().pause();
                              
               for (int i = 0; i < ConfRegister.getLaborerRequested() ; i++ )
                  laborersArray[i].pause();

               stat.pause();

               continue;
            }
            
            //Caso in cui l'utente voglia riavviare l'applicazione messa in pausa
            if (charInput == ConfRegister.RESUME_CHAR)
            {
               JobsGenerator.self().resume();
               JobsSupervisor.self().resume();
                              
               for (int i = 0; i < ConfRegister.getLaborerRequested() ; i++ )
                  laborersArray[i].resume();

               stat.resume();

               continue;
            }
            
         }
         catch (java.io.IOException ioe)
         {
            Logger.log( "IO error:" + ioe );
         }  

      }  //end while 
      
	}
	
}
