package workshop.utils;

import workshop.core.*;
import java.io.*;
/**
 * @author Michele Vetturi
 * @author Beniamino Ferrari
 * @version 1.0
 *
 * Classe per la stampa delle statistiche in output.
 */

public class Statistics implements Runnable
{
   /**
    * Il costruttore.
    *
    * @param laborersArray L'array contenente i thread degli operai
    */

   public Statistics()
   {
      selfThread = new Thread(this, "Statistics");
      
      start = System.currentTimeMillis();
      
      selfThread.start();
   }
   
   /**
    * Il metodo RUN per il thread
    */

	public void run()
	{
	File f = new File("prova2.txt");
    FileOutputStream fout=null;
    PrintStream ps=null;
       		
       		
		if(Logger.DEBUG)
		{
			
      			
      			try
      			{
       				fout=new FileOutputStream(f);
         			ps=new PrintStream(fout);   

      			}
      			catch(FileNotFoundException e)
      			{
      				System.out.println(e.getMessage());
     		 	}
		
		}
	
		

		
		
		while(true)
		{
         	try
         	{
            	selfThread.sleep(ConfRegister.TIME_BETWEEN_STAT_PRINTS);
         	}
         	catch(Exception e){}
         
        	if (status == PAUSE)
         	{
            	try
            	{
               		synchronized (this)
               	{
                	this.wait();
               	}
            }
            catch (InterruptedException ie)
            {
            }
         }



			//Stampa delle statiche dell' officina
         	synchronized (Logger.self())
         	{
         		Logger.log("\n\n\n");
         		

            	tempoSimulazione = System.currentTimeMillis() - start;
            	
                //Stampa tempo simulazione 
            	Logger.log("Tempo simulazione:"+String.valueOf(tempoSimulazione * 10)+"s"
            	          +" Tempo reale:"+String.valueOf(tempoSimulazione) + "ms\n", selfThread  );
 				
 				//Stampa job eseguiti generati
 				Logger.log("Job eseguiti/generati: " +
                             String.valueOf(Laborer.getAllJobsDone()) + "/" +
                             String.valueOf(JobsGenerator.getJobsGenerated()+"\n"), selfThread);
				
				//Stampa tempo medio e max per l'attesa di un job
				Logger.log("Tempo medio per attendere un Job: " +
                             String.valueOf(Laborer.getWaitingJobAverageTime()) + "ms reali\n", selfThread);
            	Logger.log("Tempo massimo per attendere un Job: " +
                             String.valueOf(Laborer.getWaitingJobMaxTime()) + "ms reali\n", selfThread);
				
				//Stampa tempo di attesa medio e massimo per mancanza di attrezzi
				Logger.log("Tempo medio di attesa per mancanza di attrezzi: " +
                                String.valueOf(JobsSupervisor.getWaitingToolAverageTime()) + "ms reali\n", selfThread);
            	Logger.log("Tempo massimo di attesa per mancanza di attrezzi: " +
                                String.valueOf(JobsSupervisor.getWaitingJobMaxTime()) + "ms reali\n", selfThread);
				
				
				
				//Stampa tempo di attesa medio e massimo di esecuzione job
				Logger.log("Tempo medio per eseguire un Job: " +
                                String.valueOf(Laborer.getJobExecutionAverageTime()) + "ms reali\n", selfThread);
            	Logger.log("Tempo massimo per eseguire un Job: " +
                                String.valueOf(Laborer.getJobExecutionMaxTime()) + "ms reali\n", selfThread);
				if(Logger.DEBUG)
				{	
					ps.println(String.valueOf(tempoSimulazione)+" "+String.valueOf(Laborer.getAllJobsDone())+" "+String.valueOf(JobsGenerator.getJobsGenerated()));
				}
         		if (Laborer.getAllJobsDone() >= ConfRegister.getJobRequested())
         		{
           			stop = System.currentTimeMillis();
               
            		Logger.log("\n\nLa simulazione e' terminata in " +
                                  String.valueOf(stop - start) + "ms.\n" +
                                  "Premere 'q' seguito da INVIO per uscire\n");
            		break;
         		}
         		
         	
      		}
      		
  	 	}
  	 	Logger.log("\n\n\n");
  	 	if(Logger.DEBUG)
		{
			    try
      			{
         			fout.close();
      			}
      			catch(IOException e) {
         			System.out.println(e.getMessage());
      			}
      	}
 	}

   public static Object lock = new Object();

   private Thread[] laborers;
   
   private long start;
   private long stop;

   private long tempoSimulazione;
   
   private Thread selfThread = null;
   
   private volatile int status = RUN;
   
   public static final int RUN    = 0;
   public static final int PAUSE  = 1;
   
   public synchronized void pause()
   {
      if (status == RUN)
         status = PAUSE;
   }
   
   public synchronized void resume()
   {
      if (status == PAUSE)
      {
         status = RUN;
         this.notify();
      }
   }
}